set terminal postscript eps enhanced color dashed defaultplex "Helvetica" 16
set output "experimental.eps"
set key left
set xrange [39:99]
set xlabel "Time"
set ylabel "Distribution change"
set x2tics ("1" 39, "2" 44, "3" 49, "4" 54, "5" 59, "6" 64, "7" 69, "8" 74, "9" 79, "10" 84, "11" 89, "12" 94, "13" 99)
set grid noxtics x2tics

#pp(x)=0.0428406978524391
cv(x)=0.810992
#vp(x)=0.333333333333333
pr(x)=0.271783539547712
mt(x)=0.667197872034324

plot	"experimental.dat" using 1:3 title "Volt" with lines 1,\
	"experimental.dat" using 1:5 title "Resist" with lines 2,\
	"experimental.dat" using 1:6 title "Torque" with lines 3,\
	cv(x) notitle with lines 1,\
	pr(x) notitle with lines 2,\
	mt(x) notitle with lines 3

unset output