#!/bin/bash

echo "This script constructs 3d plots"

x=(5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20)
y=(0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16)
len_x=${#x[*]}
echo "Array x has $len_x elements"
len_y=${#y[*]}
echo "Array y has $len_y elements"

for ((i=0;i<$len_x;i+=1));
do
    current_x=${x[$i]}  #considering the intervals of the length x
    echo "Consider intervals of the length $current_x"
    j=0
    while [[ $j -lt $len_y ]] && [[ ${y[$j]} -lt $current_x ]]; 
    do
        current_y=${y[$j]} #all the intervals will overlap by y elements
        echo "   Allow the intervals to overlap by $current_y elements"
        shift=$((current_x-current_y))
        echo "   So the interval shift is $shift"

        start=$((34+shift))
        echo "      So the beginning of the first interval is $start"
        echo "      Adding time starting from $start with the step $shift"
        ./add_time.pl "scaled_dist.pumpA35.$current_x.$current_y.dat" $start $shift #make "timed.scaled_dist.pumpA35.$current_x.$current_y.dat" 
        echo "      Adding a number $current_y"
        ./add_number.pl "timed.scaled_dist.pumpA35.$current_x.$current_y.dat" $current_y #make "numbered.dat"
        cat "numbered.dat" >> "across_interval.$current_x.dat"
	echo "" >> "across_interval.$current_x.dat"
	rm -f numbered.dat
        echo "      Adding a number $current_x"
        ./add_number.pl "timed.scaled_dist.pumpA35.$current_x.$current_y.dat" $current_x #make "numbered.dat"
        cat "numbered.dat" >> "across_overlap.$current_y.dat"
	echo "" >> "across_overlap.$current_y.dat"
	rm -f numbered.dat
	rm -f "timed.scaled_dist.pumpA35.$current_x.$current_y.dat" 
	let j++
    done
done

for ((i=0;i<$len_x;i+=1));
do
    current_x=${x[$i]}  #considering the intervals of the length x
    file_name="across_interval.$current_x.dat"

    plot_pp="set terminal postscript eps enhanced color dashed defaultplex \"Helvetica\" 16\nset output \"across_interval.$current_x.pp.eps\"\nset title \"Failure detection: Out Pressure, sliding window of $current_x\"\nset pm3d at b\nset view 65,5\nset dgrid3d 30,30\nset hidden3d\nsplot    \"$file_name\" using 2:1:3 notitle with lines\nunset output"
    plot_cv="set terminal postscript eps enhanced color dashed defaultplex \"Helvetica\" 16\nset output \"across_interval.$current_x.cv.eps\"\nset title \"Failure detection: Voltage, sliding window of $current_x\"\nset pm3d at b\nset view 65,5\nset dgrid3d 30,30\nset hidden3d\nsplot    \"$file_name\" using 2:1:4 notitle with lines\nunset output"
    plot_vp="set terminal postscript eps enhanced color dashed defaultplex \"Helvetica\" 16\nset output \"across_interval.$current_x.vp.eps\"\nset title \"Failure detection: In Pressure, sliding window of $current_x\"\nset pm3d at b\nset view 65,5\nset dgrid3d 30,30\nset hidden3d\nsplot    \"$file_name\" using 2:1:5 notitle with lines\nunset output"
    plot_pr="set terminal postscript eps enhanced color dashed defaultplex \"Helvetica\" 16\nset output \"across_interval.$current_x.pr.eps\"\nset title \"Failure detection: Resistance, sliding window of $current_x\"\nset pm3d at b\nset view 65,5\nset dgrid3d 30,30\nset hidden3d\nsplot    \"$file_name\" using 2:1:6 notitle with lines\nunset output"
    plot_mt="set terminal postscript eps enhanced color dashed defaultplex \"Helvetica\" 16\nset output \"across_interval.$current_x.mt.eps\"\nset title \"Failure detection: Torque, sliding window of $current_x\"\nset pm3d at b\nset view 65,5\nset dgrid3d 30,30\nset hidden3d\nsplot    \"$file_name\" using 2:1:7 notitle with lines\nunset output"

    echo -e $plot_pp | gnuplot
    echo -e $plot_cv | gnuplot
    echo -e $plot_vp | gnuplot
    echo -e $plot_pr | gnuplot
    echo -e $plot_mt | gnuplot
done

for ((i=0;i<$len_y;i+=1));
do
    current_y=${y[$i]}  #considering the intervals of the length x
    file_name="across_overlap.$current_y.dat"

    plot_pp="set terminal postscript eps enhanced color dashed defaultplex \"Helvetica\" 16\nset output \"across_overlap.$current_y.pp.eps\"\nset title \"Failure detection: Out Pressure, overlap of $current_y\"\nset pm3d at b\nset view 65,5\nset dgrid3d 30,30\nset hidden3d\nsplot    \"$file_name\" using 2:1:3 notitle with lines\nunset output"
    plot_cv="set terminal postscript eps enhanced color dashed defaultplex \"Helvetica\" 16\nset output \"across_overlap.$current_y.cv.eps\"\nset title \"Failure detection: Voltage, overlap of $current_y\"\nset pm3d at b\nset view 65,5\nset dgrid3d 30,30\nset hidden3d\nsplot    \"$file_name\" using 2:1:4 notitle with lines\nunset output"
    plot_vp="set terminal postscript eps enhanced color dashed defaultplex \"Helvetica\" 16\nset output \"across_overlap.$current_y.vp.eps\"\nset title \"Failure detection: In Pressure, overlap of $current_y\"\nset pm3d at b\nset view 65,5\nset dgrid3d 30,30\nset hidden3d\nsplot    \"$file_name\" using 2:1:5 notitle with lines\nunset output"
    plot_pr="set terminal postscript eps enhanced color dashed defaultplex \"Helvetica\" 16\nset output \"across_overlap.$current_y.pr.eps\"\nset title \"Failure detection: Resistance, overlap of $current_y\"\nset pm3d at b\nset view 65,5\nset dgrid3d 30,30\nset hidden3d\nsplot    \"$file_name\" using 2:1:6 notitle with lines\nunset output"
    plot_mt="set terminal postscript eps enhanced color dashed defaultplex \"Helvetica\" 16\nset output \"across_overlap.$current_y.mt.eps\"\nset title \"Failure detection: Torque, overlap of $current_y\"\nset pm3d at b\nset view 65,5\nset dgrid3d 30,30\nset hidden3d\nsplot    \"$file_name\" using 2:1:7 notitle with lines\nunset output"

    echo -e $plot_pp | gnuplot
    echo -e $plot_cv | gnuplot
    echo -e $plot_vp | gnuplot
    echo -e $plot_pr | gnuplot
    echo -e $plot_mt | gnuplot
done
