set terminal postscript eps enhanced color dashed defaultplex "Helvetica" 16
set output "fail2.15.10.eps"
set key left
set xrange [5:90]
set xlabel "Time"
set ylabel "Distribution change"
set x2tics ("1" 5, "2" 10, "3" 15, "4" 20, "5" 25, "6" 30, "7" 35, "8" 40, "9" 45, "10" 50, "11" 55, "12" 60, "13" 65, "14" 70, "15" 75, "16" 80, "17" 85, "18" 90)
set grid noxtics x2tics

#pp(x)=0.0466033054786984
cv(x)=0.810992
#vp(x)=0.333333333333333
pr(x)=0.271783543571557
mt(x)=0.667198244693103

plot	"failure.set2.15.10.dat" using 1:3 title "Volt" with lines 1,\
	"failure.set2.15.10.dat" using 1:5 title "Resist" with lines 2,\
	"failure.set2.15.10.dat" using 1:6 title "Torque" with lines 3,\
	cv(x) notitle with lines 1,\
	pr(x) notitle with lines 2,\
	mt(x) notitle with lines 3

unset output