#!/bin/bash

echo "This script runs models on the intervals of the length x, where the intervals are overlapped by y elements and shifted by x-y elements."

l=(1 2 3) #data sets
n=(1 2 3 4 5 6 7 8) #models
x=(17 19 21) #interval sizes
y=(12 14 16) #overlaps

len_l=${#l[*]}
echo "Array l has $len_l elements"
len_n=${#n[*]}
echo "Array n has $len_n elements"
len_x=${#x[*]}
echo "Array x has $len_x elements"
len_y=${#y[*]}
echo "Array y has $len_y elements"

for ((i=0;i<$len_x;i+=1));
do
    current_x=${x[$i]}  #considering the intervals of the length x
    echo "Consider intervals of the length $current_x"
    j=0
    while [[ $j -lt $len_y ]] && [[ ${y[$j]} -lt $current_x ]]; 
    do
	current_y=${y[$j]} #all the intervals will overlap by y elements
	echo "   Allow the intervals to overlap by $current_y elements"
	shift=$((current_x-current_y))
	echo "   So the interval shift is $shift"

	for ((d=0;d<$len_l;d+=1));
	do
	    current_l=${l[$d]}
	    data="input$current_l.txt"
	    echo "   * The dataset preprocessed as an input is given in the file $data"

	    for ((k=0;k<$len_n;k+=1));
	    do
		current_n=${n[$k]}
		model="model$current_n.txt"
		echo "      * Consider the model $model"
		start=0
		echo "      So the beginning of the first interval is $start"
		./data_windowing.pl "$data" $start $current_x $shift #split the data into the intervals "interval$current_x.$shift.*" 
		echo "      ./data-windowing.pl $data $start $current_x $shift"
		
	        #run cosmos on the intervals
		file_num=0
		for file in $( ls "interval$current_x.$shift."* );
		do
		    echo "         Copy $file into data.txt"
		    cp "$file" data.txt
		    printf -v number "%03d" "$file_num"
		    echo "         Run cosmos: time ./cosmos0823 $model > out$current_n$current_l.$current_x.$current_y.$number.res"
		    time ./cosmos0823 "$model" > "out$current_n$current_l.$current_x.$current_y.$number.res"
		    let file_num++
		done
		dir="_running_pump$current_n$current_l.$current_x.$current_y"
		echo "      Make a directory $dir"
		mkdir "$dir"
		echo "      Move out$current_n$current_l.$current_x.$current_y.* into $dir"
		mv "out$current_n$current_l.$current_x.$current_y."* "$dir"
		echo "      Remove interval files: interval$current_x.$shift.*"
		rm -f "interval$current_x.$shift."*
	    done
	done

	let j++
    done

done
echo "Done!"