#!/bin/bash


for dir in $( ls -d _running_pump* );
do
    name=$( echo "$dir" | sed 's/_running_//' )
    echo "extracting results from $name"

    dist="dist.$name.dat"
    rm -f "$dist"
    i=0
    for file in $( ls "$dir/out"*.res );
    do
	if [ $i = 0 ];
	then
            grep "INITIALIZED CURRENT-RULE" $file | sed 's/INITIALIZED CURRENT-RULE: (//' | sed 's/\(([ a-zN()]*\)$//' | sed ':a;N;$!ba;s/\n//g' | sed 's/^/# /' >> "$dist"
	fi
	
	grep "DIST" $file | sed 's/DIST: //' | sed ':a;N;$!ba;s/\n/ /g' >> "$dist"
	let i++
    done

    echo "scaling('$dist','scaled_$dist');" | octave
    
    plot="set terminal postscript eps enhanced color dashed defaultplex \"Helvetica\" 16\nset output \"model_$name.eps\"\nset title \"Failure detection on $name\"\nset key left\nplot    \"scaled_$dist\" using 1 title \"Out Pressure\" with lines, \"scaled_$dist\" using 2 title \"Voltage\" with lines, \"scaled_$dist\" using 3 title \"In Pressure\" with lines, \"scaled_$dist\" using 4 title \"Pump Resistance\" with lines, \"scaled_$dist\" using 5 title \"Motor Torque\" with lines\nunset output"

    echo -e $plot | gnuplot

done

