#!/bin/bash


sufix="norm1"
train_size=40

#sufix="norm2"
#train_size=40

#sufix="norm3"
#train_size=40

#sufix="change2"
#train_size=50

#sufix="change4"
#train_size=45

#sufix="change5"
#train_size=45

#sufix="tough1"
#train_size=50

#sufix="tough2"
#train_size=40

data="train_data_$sufix.dat"
model="new_modelA_$sufix.txt"
echo "This script runs model $model on the intervals of the length 10 of randomly chosen training data points"
echo "The training dataset preprocessed as an input is given in the file $data"

len=50
echo "Running $len iterations"
file="random_input.dat"
outfile="rand_out35.res"
resfile="threshold.$sufix"
result="thresholds.$sufix"
for ((j=17;j<24;j+=1));
do

    for ((i=0;i<$len;i+=1));
    do
	echo "ITERATION $j.$i"
	
	echo "Selecting $j random positions"
	echo "myrandint($j,$train_size);" | octave
	echo "Adding the data points from the selected positions into $file"
	./take-random-intervals.pl "$data" random.txt
	rm -f random.txt
	echo "Copy $file into data.txt"
	cp "$file" data.txt
	echo "Run cosmos: time ./cosmos0823 $model > $outfile"
	time ./cosmos0823 "$model" > "$outfile"
	echo "Removing $file"
	rm "$file"
	
	echo "Extracting results from $outfile into $resfile"
	if [ $i = 0 ];
	then
	    grep "INITIALIZED CURRENT-RULE" $outfile | sed 's/INITIALIZED CURRENT-RULE: (//' | sed 's/\(([ a-zN()]*\)$//' | sed ':a;N;$!ba;s/\n//g' | sed 's/^/# /' >> "$resfile"
	fi
	
	grep "DIST" $outfile | sed 's/DIST: //' | sed ':a;N;$!ba;s/\n/ /g' >> "$resfile"
	
	echo "Removing $outfile"
	rm "$outfile"

    done

    echo "Scaling and averaging the resulting data and saving it in savg_$resfile"
#    echo "scaled_avg_max('$resfile','savg_$resfile');" | octave
#    echo "avg_max('$resfile','savg_$resfile');" | octave
    mv "$resfile" "$resfile.$j"
#    tail -n 1 "savg_$resfile" >> "$result"
#    rm -f "savg_$resfile"

done
   
echo "Done!"