;;;;;
;;;;; The file containing definitions and operations
;;;;; that are common to every other file of the project
;;;;;

;; a boolean flag that shows whether tracing is on or off

(define trace_flag #f)

;; er : string, string -> void
;; A function that outputs the error message

(define (er name msg)
   (begin
      (display "ERROR: ")
      (display name)
      (display ": ")
      (display msg)
      (newline)))

;; the definition of the size of a data window
;;
(define window-size 15)

;; a function that collapses the successor or predessessor number
;;
(define (collapse-time t)

  (define (print-time p s t)
    (cond 
     ((zero? p) (string->symbol (string-append (symbol->string t) "+" (number->string s))))
     ((zero? s) (string->symbol (string-append (symbol->string t) "-" (number->string p))))
     (else (string->symbol (string-append (number->string (+ p s)) "+" (symbol->string t))))))

  (let loop ((l t)(p 0)(s 0))
    (cond 
     ((null? l) (+ p s))
     ((not (list? l)) (if (eq? (string->symbol (number->string 0)) l)
			  (string->symbol (number->string (- s p)))
			  (print-time p s l)))
     ((eq? (car l) 'pred) (loop (cadr l) (+ p 1) s))
     ((eq? (car l) 'succ) (loop (cadr l) p (+ s 1)))
     (else (print-time p s t)))))

