#!/bin/bash

echo "This script runs model 35 on the intervals of the length 10 of randomly chosen training data points"

data="train_data.dat"
echo "The training dataset preprocessed as an input is given in the file $data"

len=100
echo "Running $len iterations"
file="random_input.dat"
outfile="rand_out35.res"
resfile="threshold.res"
result="thresholds.res"
for ((j=11;j<19;j+=1));
do

    for ((i=0;i<$len;i+=1));
    do
	echo "ITERATION $j.$i"
	
	echo "Selecting $j random positions"
	echo "myrandint($j,35);" | octave
	echo "Adding the data points from the selected positions into $file"
	./take-random-inputs.pl "$data" random.txt
	rm -f random.txt
	echo "Copy $file into data.txt"
	cp "$file" data.txt
	echo "Run cosmos: time ./cosmos0823 pumpA35.txt > $outfile"
	time ./cosmos0823 "pumpA35.txt" > "$outfile"
	echo "Removing $file"
	rm "$file"
	
	echo "Extracting results from $outfile into $resfile"
	if [ $i = 0 ];
	then
	    grep "INITIALIZED CURRENT-RULE" $outfile | sed 's/INITIALIZED CURRENT-RULE: (//' | sed 's/\(([ a-zN()]*\)$//' | sed ':a;N;$!ba;s/\n//g' | sed 's/^/# /' >> "$resfile"
	fi
	
	grep "DIST" $outfile | sed 's/DIST: //' | sed ':a;N;$!ba;s/\n/ /g' >> "$resfile"
	
	echo "Removing $outfile"
	rm "$outfile"

    done

    echo "Scaling and averaging the resulting data and saving it in savg_$resfile"
    echo "scaled_avg('$resfile','savg_$resfile');" | octave
    rm -f "$resfile"
    tail -n 1 "savg_$resfile" >> "$result"

done
   
echo "Done!"