function ret = get_variance(arg1)

if (nargin ~= 1)
  error('Give an input file');
  return
end

data = load(arg1);
sz = size (data);

dim = min (find (size (data) > 1));
if (isempty (dim))
  dim = 1;
endif

if (prod (sz) < 1)
   error ("var: data must not be empty");
elseif (sz(dim) == 1)
   y = 0;
else
   rng = ones (1, length (sz));
   rng (dim) = sz (dim);
   y = sumsq (data - repmat(mean (data, dim), rng), dim) / (sz(dim) - 1);
endif

save('variance.dat','y');

ret = y;
return
