#!/bin/bash

echo "making data set SIMPLE"
for ((i=0;i<30;i+=1));
do
    src0="alarm_simple_$i.txt"
    src1="alarm_simple_$(($i+1)).txt"
    src2="alarm_simple_$(($i+2)).txt"
    tgt="new_simple$i.wdw"
    echo "Constructing $tgt from $src0, $src1, $src2"
    echo -e "2\t2" > "$tgt"; cat "$src0" >> "$tgt"; tail -n 150 "$src1" >> "$tgt"; tail -n 150 "$src2" >> "$tgt"
done

echo "making data set SMALL"
for ((i=0;i<30;i+=1));
do
    src0="alarm_small_$i.txt"
    src1="alarm_small_$(($i+1)).txt"
    src2="alarm_small_$(($i+2)).txt"
    tgt="new_small$i.wdw"
    echo "Constructing $tgt from $src0, $src1, $src2"
    echo -e "2\t2\t2" > "$tgt"; cat "$src0" >> "$tgt"; tail -n 150 "$src1" >> "$tgt"; tail -n 150 "$src2" >> "$tgt"
done

echo "transforming data set SIMPLE"
j=0
for i in $( ls new_simple*.wdw );
do
    tgt="new_simple$j.in"
    ./script.pl $i $tgt
    let j=j+1
done

echo "transforming data set CHANGE"
j=0
for i in $( ls new_change*.wdw );
do
    tgt="new_change$j.in"
    ./script.pl $i $tgt
    let j=j+1
done

echo "transforming data set SMALL"
j=0
for i in $( ls new_small*.wdw );
do
    tgt="new_small$j.in"
    ./script.pl $i $tgt
    let j=j+1
done

echo "running cosmos on data set SIMPLE"
for ((i=0;i<30;i+=1));
do
    src="new_simple$i.in"
    rm data.txt
    cat "$src" > data.txt
    tgt="simpleAlarm_simple$i.out"
    echo "COSMOS from $src to $tgt"
    ./cosmos0823 simpleAlarm0.dat > "$tgt"
done

echo "running cosmos on data set CHANGE"
for ((i=0;i<2;i+=1));
do
    src="new_change$i.in"
    rm data.txt
    cat "$src" > data.txt
    tgt="simpleAlarm_change$i.out"
    echo "COSMOS from $src to $tgt"
    ./cosmos0823 simpleAlarm0.dat > "$tgt"
done

echo "running cosmos on data set SMALL"
for ((i=0;i<30;i+=1));
do
    src="new_small$i.in"
    rm data.txt
    cat "$src" > data.txt
    tgt="simpleAlarm_small$i.out"
    echo "COSMOS from $src to $tgt"
    ./cosmos0823 simpleAlarm0.dat > "$tgt"
done

echo "Done!!!"