#!/bin/bash

echo "* This script computes variances of n long intervals of randomly selected training data"

data="digA.dat"
echo "* The training dataset preprocessed as an input is given in the file $data"

size=35
len=100
file="random_input.dat" # the output file from ./take-random-inputs
interval_var="inteval_variance.dat"
variance_avg="variance_avg.dat"
variance_max="variance_max.dat"

for ((j=2;j<$size;j+=1));
do
    echo "* INTERVAL $j"

    for ((i=0;i<$len;i+=1));
    do
	echo "* ITERATION $j.$i"

	echo "* Selecting $j random positions (octave myrandint.m) > random.txt"
	echo "myrandint($j,$size);" | octave

	echo "* Adding the data points from the selected positions into $file (./take-random-inputs.pl) > $file"
	./take-random-inputs.pl "$data" random.txt #outputs random_input.dat
	rm -f random.txt

	echo "* Get the variance for $file (octave get_variance.m) > variance.dat"
	echo "get_variance('$file');" | octave #produces variance.dat

	echo "* Removing $file"
	rm -f "$file"

	echo "* Adding the variance vector to $interval_var"
	cat "variance.dat" >> "$interval_var"

	echo "* Removing variance.dat"
	rm -f "variance.dat"
    done

    echo "* Compute average/max of the variances (octave max_avg.m) > average_var.dat & maximum_var.dat"
    echo "max_avg($interval_var);" | octave # returns average_var.dat and maximum_var.dat

    cat average_var.dat >> "$variance_avg"
    cat maximum_var.dat >> "$variance_max"

    echo "* Removing $interval_var"
    rm -f "$interval_var"

done
echo "* Compute the variances of the entire dataset (octave get_variance.m) > variance.dat"
echo "get_variance($data);" | octave # produces variance.dat
cat variance.dat >> "$variance_avg"
cat variance.dat >> "$variance_max"

echo "* Removing variance.dat"
rm -f "variance.dat"

echo "* Done!"